import $ from '../util/dom-core.js';
import { getParentByClassname, isEmptyElement } from '../util/util.js';

/**
 * function 生成主观题区
* @param {DomElement} $border 需要添加题的框
* @param {JSON} data  题目数据
* @param {Objec} editor 编辑器对象
 */
let generateSubjectBox = function ($border, data, editor) {
  let type = parseInt($border.attr('data-type'));
  if (type === 1) {
    editor.message.showMessage('请在主观题框中添加主观题！');
    return '';
  }

  let mergePnum = data.proData.pnum;
  let pnum = data.pnum;

  if (mergePnum && mergePnum.length > 0) {
    pnum = mergePnum +''+ pnum;
  }

  let $box = $('<div class = "lsiten-subject-box js-lsiten-question"><p>'+pnum+'、</p><p><br/></p><p><br/></p><p><br/></p></div>');
  $box.attr('data-type', 3);
  let $selectionElem = editor.selection.getSelectionContainerElem();
  let $borderContent = getParentByClassname($selectionElem, 'border-content');
  if (!$borderContent) {
    console.log("%c请在框内添加该题！", "color:red");
    return '';
  }

  $borderContent.append($box);

  if ( isEmptyElement($borderContent[0].firstChild) ) {
    $borderContent[0].removeChild($borderContent[0].firstChild);
  }

  editor.selection.getRange().setStart($box[0], 0);
  if (editor.selection.getRange()) {
    editor.selection.restoreSelection();
  }
  editor.selection.saveRange();
  editor.selection.collapseRange();
}

export default {
  generateSubjectBox: generateSubjectBox
}