import $ from './dom-core';
import {isEmptyElement} from './util.js'
let questionUtils = function () {

}

questionUtils.prototype = {
  constructor: questionUtils,
  /**
   * function 切分题目框
   * @param {DomElement} $border 题框
   * @param {Object} csize 栏size
   */
  _splitBorder: function ($border, csize) {
    let type = parseInt($border.attr('data-type'));
    switch (type) {
      case 1:
      return this._spiltObjectBorder($border, csize);
      break;
      case 2:
      return this._spiltSubjectBorder($border, csize);      
      break;
    }
  },
  /**
   * function 切分客观题框
   * @param {DomElement} $border 题框
   */
  _spiltObjectBorder: function ($border, csize) {
    let $nextBorder = $border.clone(false);
    let childs = $border.childNodes();
    let cLength = childs.length;
    if (cLength > 0) {
      let i = cLength - 1;
      while (i >= 0) {
        let bSizeBorder = $border.getSizeData();
        let row = childs[i];
        let $row = $(row);
        let $nextRow = $row.clone(false);
        if (bSizeBorder.bottom > csize.bottom) {
          this._splitObjectRow($nextRow, $row, $border, csize);
          if ($nextRow.childNodes().length > 0) {
            if ($nextBorder.childNodes().length > 0) {
              let firstChildNode = $nextBorder[0].firstChild;
              $nextBorder[0].insertBefore($nextRow[0], firstChildNode);
              $(firstChildNode).removeClass('js-split-row' + (i+1));
              $nextRow.addClass('js-split-row' + i);
              $row.addClass('js-split-row'  + i)
            } else {
              $nextBorder.append($nextRow);
              $nextRow.addClass('js-split-row' + i);
              $row.addClass('js-split-row'  + i)
            }
          }
        }
        i--;
        if (!$row.childNodes().length) {
          $nextRow.removeClass('js-split-row' + i);
          $row.remove();
        }
      }
    }
    if ($nextBorder.childNodes().length > 0) {
      $nextBorder[0].firstChild.style.borderTop = 'none';
      return $nextBorder;
    } else {
      return false;
    }
  },
  /**
   * function 处理客观题的row
   * @param {DomElement} $nextDiv 下一段的div
   * @param {DomElement} $item 文本节点
   * @param {DomElement} $border 所在框
   * @param {Object} csize 栏size
   */
  _splitObjectRow: function ($nextDiv, $item, $border, csize) {
    // debugger;
    let childs = $item.childNodes();
    let nextDivContentChilds =  [];
    let nextDivContentChildsLength =  0;
    nextDivContentChilds = $nextDiv.childNodes();
    nextDivContentChilds.length > 0 && (nextDivContentChildsLength = nextDivContentChilds.length);
    let cLength = childs.length;
    let firstColumn = childs[0];
    if (!firstColumn) {
      return '';
    }
    let $firstColumn = $(firstColumn);
    let lastQuestion = parseInt($firstColumn.attr('data-question-count')) - 1;
    lastQuestion < 0 ? lastQuestion = 0 : '';
    for (let i =0; i < cLength; i++) {
      let child = childs[i].firstChild; //栏下有一个内容div
      let $child = $(child);
      if (nextDivContentChildsLength > 0) {
        if (!nextDivContentChilds[i]) {
          console.log("%c数据错误！", "color:red");          
          return '';
        }
        let $nextContent = $(nextDivContentChilds[i].firstChild);
        let childsQuestion = $child.childNodes();
        let nextQuestion =  childsQuestion ? childsQuestion[lastQuestion] : null;
        if (nextQuestion) {
          $nextContent[0].insertBefore(nextQuestion, $nextContent[0].firstChild);
          let $childColumn = $(childs[i]);
          let columnQuestion = parseInt($childColumn.attr('data-question-count')) - 1;
          columnQuestion < 0 ? columnQuestion = 0: '';
          $childColumn.attr('data-question-count', columnQuestion);
        }
      } else {
        let $nextColum = $(childs[i]).clone(false);
        let $nextContent = $child.clone(false);
        let childsQuestion = $child.childNodes();
        let nextQuestion =  childsQuestion ? childsQuestion[lastQuestion] : null;
        if (nextQuestion) {
          $nextContent.append($(nextQuestion));
          let $childColumn = $(childs[i]);
          let columnQuestion = parseInt($childColumn.attr('data-question-count')) - 1;
          columnQuestion < 0 ? columnQuestion = 0: '';
          $childColumn.attr('data-question-count', columnQuestion);
          $nextColum.append($nextContent);
        } else {
          i === 0 ? $nextColum.append($child) : $nextColum.append($nextContent);
        }
        $nextDiv.append($nextColum);
      }

      if (i === 0) {
        let $columnPrev = $child;
        if (!$columnPrev.childNodes().length) {
          $item.html('');
        }
      }
    }
    if (firstColumn.firstChild) {
      let contentSize = $(firstColumn.firstChild).getSizeData();
      $item.find('.js-option-column').css('min-height', contentSize.height + 'px');
    }
    let bSizeBorder = $border.getSizeData();
    if (bSizeBorder.bottom > csize.bottom) {
      this._splitObjectRow($nextDiv, $item, $border, csize);
    }

  },


    /**
   * function 切分主观题框
   * @param {DomElement} $border 题框
   * @param {Object} csize 栏size
   */
  _spiltSubjectBorder: function ($border, csize) {
    let $nextBorder = $border.clone(false);
    let $content = $($border[0].firstChild);
    if ($content.attr('class') === 'border-content') {
      let childrens = $content.childNodes();
      let $nextContent = $content.clone(false);
      let html = $content.html().toLowerCase();     
      if (childrens.length < 1 || html === '' || html === '<p></p>' || html === '<p><br></p>' || html === '<p><br/></p>' || html === '<br/>' || html === '<br>') {
        $nextBorder.append($content);
      } else {
        for (let i =(childrens.length -1); i >= 0; i--) {
          let item = childrens[i];
          let bSize = $border.getSizeData();
          if (bSize.bottom > csize.bottom) {
            if (item.nodeType === 3) {
              this._handerText($nextBorder, item, csize, $border);
            } else {
              let $item = $(item);
              let className = $item.attr('class');
              if (className && className.indexOf('js-lsiten-question') > -1) {
                let type = parseInt($item.attr('data-type'));
                let nextDivFirstDiv = $nextContent[0].firstChild;
                switch (type) {
                  case 1:
                  let $nextChoice = this._handleChoice($item, csize, $border);
                  nextDivFirstDiv = $nextContent[0].firstChild;
                  if (nextDivFirstDiv) {
                    $nextContent[0].insertBefore($nextChoice[0].firstChild, nextDivFirstDiv);
                  } else {
                    $nextContent[0].appendChild($nextChoice[0].firstChild);
                  }

                  break;
                  case 2:
                  let $nextJudge = this._handleJudge($item, csize, $border);
                  nextDivFirstDiv = $nextContent[0].firstChild;
                  if (nextDivFirstDiv) {
                    $nextContent[0].insertBefore($nextJudge[0].firstChild, nextDivFirstDiv);
                  } else {
                    $nextContent[0].appendChild($nextJudge[0].firstChild);
                  }
                  break;
                  case 3:
                  let $nextsubject = this._handleSubject($item, csize, $border);
                  if ($nextsubject) {
                    nextDivFirstDiv = $nextContent[0].firstChild;
                    if (nextDivFirstDiv) {
                      $nextContent[0].insertBefore($nextsubject[0], nextDivFirstDiv);
                    } else {
                      $nextContent.append($nextsubject);
                    }
                    $nextsubject.addClass('js-split-problem');
                    $item.addClass('js-split-problem');
                    $nextsubject.attr('data-rm', 0);
                    if (isEmptyElement($item[0])) {
                      $item.remove();
                      $nextsubject.attr('data-rm', 1);
                    }
                  }
                  break;
                  case 4:
                  let $nextWritting = this._handleWritting($item, csize, $border);
                  if ($nextWritting) {
                    nextDivFirstDiv = $nextContent[0].firstChild;
                    if (nextDivFirstDiv) {
                      $nextContent[0].insertBefore($nextWritting[0], nextDivFirstDiv);
                    } else {
                      $nextContent.append($nextWritting);
                    }
                    $nextWritting.addClass('js-split-writting-problem');
                    $item.addClass('js-split-writting-problem');
                    $nextWritting.attr('data-rm', 0);
                    if (isEmptyElement($item[0])) {
                      $item.remove();
                      $nextWritting.attr('data-rm', 1);
                    }
                  }
                  break;
                }
              } else if (className && className.indexOf('js-lsiten-options-box') > -1) {
                // 选做题处理
                let $nextOption = this._handleOptions($item, csize, $border);
                let nextDivFirstDiv = $nextContent[0].firstChild;
                if (nextDivFirstDiv) {
                  $nextContent[0].insertBefore($nextOption[0].firstChild, nextDivFirstDiv);
                } else {
                  $nextContent[0].appendChild($nextOption[0].firstChild);
                }
              } else {
                let $nextDiv = this._handerDiv($item, csize, $border);
                if ($nextDiv.childNodes().length > 0) {
                  let nextDivFirstDiv = $nextContent[0].firstChild;
                  if (nextDivFirstDiv) {
                    $nextContent[0].insertBefore($nextDiv[0], nextDivFirstDiv);
                  } else {
                    $nextContent.append($nextDiv)
                  }
                }

                if (isEmptyElement($item[0])) {
                  $item.remove();
                }
              }
            }
          }
        }

        if ($nextContent.childNodes().length > 0) {
          $nextBorder.append($nextContent);
        }
      }
      return $nextBorder.childNodes().length > 0 ? $nextBorder: false;
    } else {
      $border.remove();
      return false;
    }
  },
  /**
   * function 处理纯文字
   * @param {DomElement} $nextDiv 下一段的div
   * @param {DomElement} item 文本节点
   * @param {Object} csize 栏size
   * @param {DomElement} $border 所在框
   */
  _handerText: function ($nextDiv, item, csize, $border) {
    let text = item.nodeValue;
    let nextNode = item.nextSibling;
    let parentNode = item.parentNode;
    let span = document.createElement('span');
    span.appendChild(item);
    if (nextNode) {
      parentNode.insertBefore(span, nextNode);
    } else {
      parentNode.appendChild(span);
    }
    let $span =  $(span);
    let textSize = $span.getSizeData();
    if (textSize.top > csize.bottom) {
      $nextDiv[0].appendChild(item);
      $span.remove();
    } else {
      let textLength = text.length;
      let i = 0;
      while(--textLength) {
        span.innerHTML = text.substr(0, textLength);
        // 要看框的底部是否在栏内
        textSize = $border.getSizeData();
        if (textSize.bottom < csize.bottom) {
          break;
        }
      }
      let prevText = text.substr(0, textLength);
      let nextText = text.substring(textLength);
      span.outerHTML = prevText;
      $(parentNode).addClass('js-split-item');
      $nextDiv[0].appendChild(document.createTextNode(nextText));
      $nextDiv.addClass('js-split-item');
    }
  },
  /**
   * function 处理纯普通div
   * @param {DomElement} $item 纯普通div
   * @param {Object} csize 栏size
   *  @param {DomElement} $border 所在框
   */
  _handerDiv: function ($item, csize, $border) {
    let $nextDiv = $item.clone(false);
    this._splitNormalDiv($nextDiv,$item, csize, $border);
    return $nextDiv;
  },
  /**
   * function 切分纯普通div
   * @param {DomElement} $nextDiv 纯普通div
   * @param {Node} $item 纯普通div
   * @param {Object} csize 栏size
   * @param {DomElement} $border 所在框
   */
  _splitNormalDiv: function ($nextDiv, $item, csize, $border) {
    let bSize = $border.getSizeData();
    if (bSize.bottom < csize.bottom) {
      return false;
    }
    let childs = $item.childNodes();
    let cLength = childs.length;
    if (cLength > 0) {
      for (let i =(cLength -1); i >= 0; i--) {
        let child = childs[i];
        if (child.nodeType === 3) {
          this._handerText($nextDiv, child, csize, $border);
        } else {
          let tName = child.tagName.toLowerCase();
          if (tName === 'br') {
            let nextFirstChild = $nextDiv[0].firstChild;
            if (nextFirstChild) {
              $nextDiv[0].insertBefore(child, nextFirstChild);
            } else {
              $nextDiv[0].appendChild(child);
            }
          } else if (tName === 'img') {
            let nextFirstChild = $nextDiv[0].firstChild;
            if (nextFirstChild) {
              $nextDiv[0].insertBefore(child, nextFirstChild);
            } else {
              $nextDiv[0].appendChild(child);
            }
          } else {
            let $child = $(child);
            let $nextChild = $child.clone(false);
            this._splitNormalDiv($nextChild, $child, csize, $border);
            if ($nextChild.childNodes().length > 0) {
              let nextDivFirstDiv = $nextDiv[0].firstChild;
              if (nextDivFirstDiv) {
                $nextDiv[0].insertBefore($nextChild[0], nextDivFirstDiv);
              } else {
                $nextDiv.append($nextChild)
              }
            }
            if ($child[0].innerHTML === '') {
              $child.remove();
            }
          }
        }
      }
    }
  },
  /**
   * function 处理选择题div
   * @param {DomElement} $item 纯普通div
   * @param {Object} csize 栏size
   * @param {DomElement} $border 所在框
   */
  _handleOptions: function ($item, csize, $border) {
    let $nextNext = $('<div></div>');
    $nextNext.append($item);
    return $nextNext;
  },
  /**
   * function 处理选择题div
   * @param {DomElement} $item 纯普通div
   * @param {Object} csize 栏size
   * @param {DomElement} $border 所在框
   */
  _handleChoice: function ($item, csize, $border) {
    let $nextNext = $('<div></div>');
    $nextNext.append($item);
    return $nextNext;
  },
  /**
   * function 处理判断题div
   * @param {DomElement} $item 纯普通div
   * @param {Object} csize 栏size
   * @param {DomElement} $border 所在框
   */
  _handleJudge: function ($item, csize, $border) {
    let $nextNext = $('<div></div>');
    $nextNext.append($item);
    return $nextNext;
  },
  /**
   * function 处理客观题Div
   * @param {DomElement} $item 纯普通div
   * @param {Object} csize 栏size
   * @param {DomElement} $border 所在框
   */
  _handleSubject: function ($item, csize, $border) {
    let $nextSubject = $item.clone(false);
    this._splitNormalDiv($nextSubject, $item, csize, $border);
    !$item.childNodes().length && $item.remove();
    return $nextSubject.childNodes().length > 0 ? $nextSubject : false;
  },
  /**
   * function 处理作文题Div
   * @param {DomElement} $item 纯普通div
   * @param {Object} csize 栏size
   * @param {DomElement} $border 所在框
   */
  _handleWritting: function ($item, csize, $border) {
    let childs = $item.childNodes();
    let cLength = childs.length;
    let $nextWritting = $item.clone(false);
    if (cLength > 0) {
      let i = cLength - 1;
      while (i >= 0) {
        let bSize = $border.getSizeData();
        let child = childs[i];
        let $child = $(child);
        if (bSize.bottom > csize.bottom) {
          if (child.className.indexOf('lsiten-title') > -1) {
            if (!isEmptyElement(child)) { 
              // 作文标题
              let $nextLsitenTitle = $child.clone(false);
              this._splitNormalDiv($nextLsitenTitle, $child, csize, $border);
              if ( $nextLsitenTitle.childNodes().length > 0 ) {
                let nextDivFirstDiv = $nextWritting[0].firstChild;
                if (nextDivFirstDiv) {
                  $nextWritting[0].insertBefore($nextLsitenTitle[0], nextDivFirstDiv);
                } else {
                  $nextWritting.append($nextLsitenTitle);
                }
                $nextLsitenTitle.addClass('js-split-writting-title');
              }
            } else {
              $child.remove();
            }
          } else if (child.className.indexOf('lsiten-border-box') > -1){
            // 作文格子
            let $nextLsitenBorder = $child.clone(false);
            let rows = $child.childNodes();
            let rowLength = rows.length;
            if ( rowLength > 0 ) {
              let k = rowLength - 1;
              while ( k >= 0 ) {
                let bSizeBorder = $border.getSizeData();
                if (bSizeBorder.bottom > csize.bottom) {
                  let $rowItem = $(rows[k]);
                  let nextDivFirstDiv = $nextLsitenBorder[0].firstChild;
                  if (nextDivFirstDiv) {
                    $nextLsitenBorder[0].insertBefore($rowItem[0], nextDivFirstDiv);
                  } else {
                    $nextLsitenBorder.append($rowItem);
                  }
                }
                k--;
              }
            } else {
              $nextLsitenBorder.remove();
            }

            if ($nextLsitenBorder.childNodes().length > 0) {
              let nextDivFirstDiv = $nextWritting[0].firstChild;
              if (nextDivFirstDiv) {
                $nextWritting[0].insertBefore($nextLsitenBorder[0], nextDivFirstDiv);
              } else {
                $nextWritting.append($nextLsitenBorder);
              }
              $nextLsitenBorder.addClass('js-split-writting-border');
            } 
          }
        }
        i--;
        isEmptyElement($child[0]) && $child.remove();
      }
    }
    return $nextWritting.childNodes().length > 0 ? $nextWritting : false;
  }
}

export default questionUtils;
