import $ from './util/dom-core.js';
import {getParentByClassname, getParentNodeByClass, isEmptyElement, trim} from './util/util.js';
import QuestionTools from './util/question';
import QuestionPrevTools from './util/questionPrev';
import JQuery from 'jquery';
let yzPage = function (manage, $page) {
  this.manage = manage;
  this.editor = manage.editor;
  this.pageIndex = this.manage.pageIndex;
  this.id = ('lsiten_editor_page_'+Math.random()).replace('.','_') + this.pageIndex;
  this.$textElem = $('<div class="js-page-content" id = "' +this.id+ '"></div>');
  this.$colums = [];
  this.paragraphIndex = 0;
  // 已经初始化后的内容
  this.$page = $page;
  this._init();
  manage.$el.append(this.$textElem);
}

yzPage.prototype = {
  constructor: yzPage,
  _init: function () {
    this._initStyles();
    this._initColumn();
    // this._initPositionPlaceholder();
    // this._initPAndNPlaceholder();
    this.questionTools = new QuestionTools();
    this.questionPrevTools = new QuestionPrevTools();
    this._addHeader();
  },
  /**
   * function 初始化样式
   */
  _initStyles: function () {
    this.$textElem.css('position', 'relative')
                  .css('outline', 'none')
                  .css('word-wrap', 'break-word')
                  .css('font-size', '14px')
                  .css('-webkit-line-break', 'after-white-space')
                  .css('height', this._pagesHeight[this.editor.pageSize])
  },
  /**
   * function 初始化栏
   */
  _initColumn: function () {
    let colums = this.editor.columnNumber;
    let height = this._pagesHeight[this.editor.pageSize];
    let widthColumn = 100 / colums + '%';
    // 初始化栏数据
    let $columnData = [];
    if (this.$page) {
      $columnData = this.$page.find('.js-column');
    }
    for (let i = 0; i < colums; i++) {
      let $columItem = null;
      if ($columnData[i]) {
        $columItem = $($columnData[i]);
      } else {
        $columItem = $('<div class="lsiten-colum-' + this.pageIndex + '-' + i + ' js-column"></div>');
        $columItem.attr('data-column-i', i);
        $columItem.attr('data-column-page', this.pageIndex);
        // $columItem.attr('contenteditable', true);
        $columItem.css('height', height);
        $columItem.css('position', 'relative');
        $columItem.css('overflow', 'hidden');
        $columItem.css('float', 'left');
        $columItem.css('width', widthColumn);
      }
      this.$colums.push($columItem);
      this.$textElem.append($columItem);
    }
    this.currentColumn = 0;
  },
  /**
   * function 添加表头
   */
  _addHeader: function () {
    this.editor.cmd.do('answerHeader', this);
  },

  /**
   * function 添加段落
   */
  addParagraph: function () {
    let $column = this.$colums[this.currentColumn];
    let $paragraph = $('<div class="js-paragraph-view"></div>');
    $paragraph.css('margin', 0)
              .css('padding', '0 25px')
              .css('outline', 'none')
              .css('box-sizing', 'border-box')
              .css('white-space', 'pre-wrap')
              .css('line-height', '1.75')
              .css('text-align', 'left');
    let index = this.pageIndex + '-' + this.paragraphIndex++;
    $paragraph.attr('data-index', index);
    let $currentParagraph = this.manage.editorPosition.currentParagraph;
    if (!$currentParagraph && !$column[0].childNodes.length) {
      $column.append($paragraph);
    } else {
      $paragraph.insertAfter($currentParagraph);
    }
    return $paragraph;
  },
  // 更新头部
  updateHeader: function () {
  },

  _placeholderTemplate: function () {
    let $postionDom = $('<div></div>');
    $postionDom.css('background-color', '#000');
    $postionDom.css('position', 'absolute');
    $postionDom.attr('contenteditable', false);
    $postionDom.html('&#8203;');
    $postionDom.css('width', '25px');
    $postionDom.css('height', '16px');
    return $postionDom;
  },
  // 生成正反面定位符
  _initPAndNPlaceholder: function () {
  },
  // 初始化占位符
  _initPositionPlaceholder: function () {
    let $columns = this.$colums;
    let clength = $columns.length;
    let cwidth = this._pagesWidth[this.editor.pageSize] / clength;
    let lastIndex = clength - 1;
    for (let i = 0; i < clength; i++) {
      let $template = this._placeholderTemplate();
      let $templateb = this._placeholderTemplate();
      let left = i * cwidth - 25;
      if (i > 0) {
        left += 15
        $template.css('left', left + 'px').css('top', '-16px');
        this.$textElem.append($template);
      }
      
      $templateb.css('left', left + 'px').css('bottom', '-16px');
      this.$textElem.append($templateb);

      if (i === lastIndex) {
        let $template1 = this._placeholderTemplate();
        let $template1b = this._placeholderTemplate();
        $template1.css('right', '-25px').css('top', '-16px');
        $template1b.css('right', '-25px').css('bottom', '-16px');
        this.$textElem.append($template1);
        this.$textElem.append($template1b);
      }
    }
  },
  // 更新跨栏符
  _updateCrossColumn: function ($column) {
  },
  
  
  _pagesHeight: {
    'A4': '970px',
    'A3': '970px'
  },
  _pagesWidth: {
    'A4': 653,
    'A3': 1447
  }
}

export default yzPage
